//+------------------------------------------------------------------+
//|                                                      _ZZstat.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern    int       bars = 10000;
extern    int       prec = 5;
int  res[1000][2];double dig[300][3],prom[300];
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start(){int i,pi,x,y,c;double sum;
//--------------
double prewprice;
for(i=0;i<bars;i++){
  double pr = iCustom(Symbol(),0,"ZigZag",12,5,3,0,i);
  if(pr!=0){
    if(prewprice!=0){res[x][0]=MathAbs(pr-prewprice)/Point;if(pi!=0){res[x][1]=i-pi;}pi=i;x++;}
    prewprice=pr;
  }
}  
Print(x);
ArrayResize(res,x);
ArraySort(res,WHOLE_ARRAY,0,MODE_DESCEND);
for(i=0;i<x;i++){res[i][0]=((res[i][0]/prec)*prec);} 
y=-1;
for(i=x;i>=0;i--){
  if(dig[y][0]!=res[i][0]){
    y++;
    dig[y][0]=res[i][0];
    dig[y][1]=1;
    sum++;
    dig[y][2]=dig[y][2]+res[i][1]; 
    if(y>0){
      dig[y-1][2]=dig[y-1][2]/dig[y-1][1];
      c=0;
    }
    c++;   
  }else{
    dig[y][1]++;
    dig[y][2]=dig[y][2]+res[i][1];
    sum++;
    c++;
  }
}

ArrayResize(dig,y);
double pers = 100/sum;
for(i=0;i<y;i++){dig[i][1]=NormalizeDouble(dig[i][1]*pers,1);}
string comm;
for(i=0;i<y;i++){comm = comm + DoubleToStr(dig[i][0],0) + "  "+ DoubleToStr(dig[i][1],1)+"  "+ DoubleToStr(dig[i][2],1)+"\n";}
//--------------
Comment(comm);  
int hd=FileOpen(Symbol()+Period()+"zz_stat.csv",FILE_CSV|FILE_WRITE,",");
double max;
for(i=0;i<y;i++){if(max<dig[i][1]){max=dig[i][1];}FileWrite(hd,dig[i][0]+";"+dig[i][1]+";"+(dig[i][1]/dig[i][2])*10);}//if(((dig[i][1]/dig[i][2])*100)<max){break;}}
FileClose(hd);
Print(max,"  ",((dig[i][1]/dig[i][2])*10));
return;}
//+------------------------------------------------------------------+